Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2398 by niro, Tue Jan 7 13:06:55 2014 UTC revision 2483 by niro, Wed Jan 8 10:36:44 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  # ignore the environment  # setup locales
11  LC_ALL=C  TEXTDOMAIN=installer
12    LC_MESSAGES=C
13    
14  # include dir  # include dir
15  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
16    
# Line 22  die() Line 24  die()
24   exit 1   exit 1
25  }  }
26    
27  # configuration  # load common includes
28  if [ -e %SYSCONFDIR%/installer.conf ]  for inc in %SYSCONFDIR%/installer.conf \
29  then   ${INSTALLER_LIBDIR}/functions/common.sh \
30   source %SYSCONFDIR%/installer.conf   ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
31  else   ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
32   die "/etc/installer.conf not found"   ${INSTALLER_LIBDIR}/functions/bootloader.sh \
33  fi   ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
34     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
35    do
36     if [ -e ${inc} ]
37     then
38     source "${inc}"
39     else
40     die "'${inc}' not found"
41     fi
42    done
43    
44  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
45  # -> now in images.conf  # -> now in images.conf
# Line 45  else Line 56  else
56   die "/mnt/cdrom/system/images.conf not found"   die "/mnt/cdrom/system/images.conf not found"
57  fi  fi
58    
 # includes  
 source ${INSTALLER_LIBDIR}/functions/hwdetection.sh  
   
59  ### System/Config Version  ### System/Config Version
60  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
61  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
62    
63    # some sane defaults
64  CDROOT="${DEFAULT_CDROOT}"  CDROOT="${DEFAULT_CDROOT}"
65  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
66    KERNELPKG="${DEFAULT_KERNELPKG}"
67  # standard kernel opts  KERNELOPTS="${DEFAULT_KERNELOPTS}"
 KERNELOPTS="quiet video=1024x768"  
   
 # grub options  
68  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
69  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
70  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
71  SPECIALDEVICE=""  SPECIALDEVICE=""
72  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
   
 # target filesystem  
73  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
74    
 #################################################  
 #  DIALOG BOXEN #  
 #################################################  
   
 dialog_die()  
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
 {  
  local retval  
   
  yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"  
  retval=$?  
  if [[ ${retval} -eq 1 ]]  
  then  
  clear  
  echo $"The process was aborted."  
  exit 1  
  fi  
 }  
   
 dialog_setup_hdd_info()  
 {  
  local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_auto()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
75    
76   dialog \  ### helper scripts ###
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
 }  
77    
78  dialog_setup_system_menu()  trap_exit()
79  {  {
80   local i   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
81     is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
82     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
83     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
84     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
85    
86   i=$(dialog \   echo $"Installation aborted."
87   --backtitle "${TITLE}" \   exit 1
  --title "[ Festplatten Partitionierung ]" \  
  --cancel-label "Abbrechen" \  
  --ok-label "Weiter" \  
  --stdout \  
  --colors \  
  --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \  
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  case "${i}" in  
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "3") run_install_flash ;;  
  "") dialog_setup_system_menu;;  
  esac  
  fi  
 }  
   
 dialog_hardware_detection()  
 {  
  local i  
  local hwtmp  
   
  if [ -x $(type -P mktemp) ]  
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
   
  run_hardware_detection_disks  
   
  echo "dialog \\"  > ${hwtmp}  
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
   
  if [[ ! -z ${ALL_DISKS} ]]  
  then  
  for i in ${ALL_DISKS}  
  do  
  echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  done  
  fi  
   
  if [[ ! -z ${ALL_CDROMS} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " CDROM Laufwerke:\n \\" >> ${hwtmp}  
  for i in ${ALL_CDROMS}  
  do  
  echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  done  
  fi  
   
  # other devices  
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}  
  fi  
   
  echo " \" 14 70" >> ${hwtmp}  
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info  
  setup_hdd_partitions_manuell  
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell_flash()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_flash  
  setup_hdd_partitions_manuell_flash  
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_auto()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
  fi  
 }  
   
 run_hardware_detection_disks()  
 {  
  local bootdev  
   
  # all disks but exclude ramdisks  
  export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')  
  # remove the boot device from ALL_DISKS if it was an usbstick  
  if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]  
  then  
  bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"  
  export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")  
  fi  
  export ALL_CDROMS="$(get_hwinfo cdrom)"  
 }  
   
 dialog_setup_hdd_create_partitions()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Disk Partitionen ..." 3 70  
 }  
   
 dialog_setup_hdd_format()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Datei-Systeme ..." 3 70  
 }  
   
 dialog_install_settings()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Speichere System-Einstellungen ..." 3 70  
 }  
   
 dialog_install_system_image()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --gauge "Kopiere System-Image ..." 6 80  
88  }  }
89    
90  dialog_install_meter()  install_meter()
91  {  {
92   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
93   do   do
# Line 406  dialog_install_meter() Line 100  dialog_install_meter()
100   return 0   return 0
101  }  }
102    
   
 dialog_install_bootsector()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Schreibe den Bootsektor ..." 3 70  
 }  
   
 dialog_install_successful()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81  
 }  
   
 dialog_install_failure()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\  
  Fehler bei ${ERROR}, RetVal: ${RETVAL} \  
  " 10 81  
 }  
   
 dialog_main()  
 {  
  METHOD=0  
   
  while [[ ${METHOD} -le 2 ]]  
  do  
  METHOD=$(dialog \  
  --backtitle "${TITLE}" \  
  --no-cancel \  
  --ok-label "Weiter" \  
  --stdout \  
  --menu "Konfiguration" 14 70 5 \  
  "1" "AutoSta_LX installieren" \  
  "2" "Uebersicht gefundener Laufwerke" \  
  "3" "Beenden und neustarten" \  
  "4" "Beenden und eine Shell starten")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && exit 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  case ${METHOD} in  
  "1") dialog_setup_system_menu ;;  
  "2") dialog_hardware_detection ;;  
  "3") install_do_reboot ;;  
  "4") /bin/bash --login -i ;;  
  esac  
  fi  
  done  
 }  
   
 #################################################  
 # Install Komandos #  
 #################################################  
103  run_hardware_detection()  run_hardware_detection()
104  {  {
105   local hwinfo   local hwinfo
106    
107   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
108    
109   # check for special devices/clients:   ## check for special devices/clients:
110   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
111   local removable=0   #local removable=0
112   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
113   then   #then
114   for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
115   do   #do
116   if [[ $(< ${i}) = 1 ]]   #if [[ $(< ${i}) = 1 ]]
117   then   #then
118   removable=1   #removable=1
119   fi   #fi
120   done   #done
121     ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
122   # only add this for grub legacy, grub2 detect these settings on its own  
123   export GRUBLEGACYOPTS="rootdelay=8"   ## only add this for grub legacy, grub2 detect these settings on its own
124   # there are to zotac types in the wild, nvidia based gfx and intel   #export GRUBLEGACYOPTS="rootdelay=8"
125   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   ## there are to zotac types in the wild, nvidia based gfx and intel
126   then   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
127   export SPECIALDEVICE="zotac_nvidia"   #then
128   else   #export SPECIALDEVICE="zotac_nvidia"
129   export SPECIALDEVICE="zotac_intel"   #else
130   fi   #export SPECIALDEVICE="zotac_intel"
131   fi   #fi
132     #fi
133    
134   # check for special devices/clients:   # check for special devices/clients:
135   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 522  run_hardware_detection() Line 158  run_hardware_detection()
158   fi   fi
159  }  }
160    
161  hdd_size_below_256mb()  run_hardware_detection_disks()
162  {  {
163   local hdd="$1"   local bootdev
  local size  
  local retval  
  [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"  
164    
165   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   # all disks but exclude ramdisks
166   if [[ ${size} -le 257000000 ]]   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
167     # remove the boot device from ALL_DISKS if it was an usbstick
168     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
169   then   then
170   retval="0"   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
171   else   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  retval="1"  
172   fi   fi
173     export ALL_CDROMS="$(get_hwinfo cdrom)"
  return "${retval}"  
174  }  }
175    
176  setup_hdd_partitions_auto()  setup_hdd_partitions_auto()
177  {  {
178   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
179    
180     # sanity check - should not happen
181     if is_mounted --device "${ROOTHDD}"
182     then
183     echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
184     umount "${ROOTHDD}"
185     fi
186    
187   # run this only if FDISKPARTITIONBELOW256MB is not already 1   # run this only if FDISKPARTITIONBELOW256MB is not already 1
188   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
189   then   then
# Line 602  EOF Line 242  EOF
242   fi   fi
243  }  }
244    
245  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || dialog_die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
246  {  {
247   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
248     SWAPHDD=""
249   ## hdds partitionieren manuell   BOOTHDD=""
250   cfdisk ${HDD} || dialog_die   cfdisk ${HDD} || dialog_die
251  }  }
252    
253  setup_hdd_format()  setup_hdd_format()
254  {  {
255   mkswap ${SWAPHDD} || dialog_die   # sanity check - should not happen
256   mke2fs -j -q ${BOOTHDD} || dialog_die   if is_mounted --device "${ROOTHDD}"
257   mke2fs -j -q ${ROOTHDD} || dialog_die   then
258  }   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
259     umount "${ROOTHDD}"
260     fi
261    
262  setup_hdd_format_flash()   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
 {  
  mke2fs -j -q ${ROOTHDD} || dialog_die  
263  }  }
264    
265  install_mount_rootfs()  install_mount_rootfs()
266  {  {
267   swapon ${SWAPHDD} || dialog_die   is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"
  mount ${ROOTHDD} ${INSTALLROOT} || dialog_die  
  install -d ${INSTALLROOT}/boot || dialog_die  
  mount ${BOOTHDD} ${INSTALLROOT}/boot || dialog_die  
  cd ${INSTALLROOT} || dialog_die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLROOT} || dialog_die  
268   install -d ${INSTALLROOT}/boot || dialog_die   install -d ${INSTALLROOT}/boot || dialog_die
  cd ${INSTALLROOT} || dialog_die  
269  }  }
270    
271  install_system_image()  install_system_image()
272  {  {
273     pushd ${INSTALLROOT} > /dev/null
274   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
275     popd > /dev/null
276  }  }
277    
278  install_bootsector_chroot()  install_system_settings()
279  {  {
280   local my_roothdd   local CONFIG
  local grubconf=${INSTALLROOT}/boot/grub/grub.conf  
  local grub2conf=/boot/grub/grub.cfg  
281    
282   # check for grub2   # write fstab
283   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]   CONFIG="${INSTALLROOT}/etc/fstab"
284   then   clearconfig
285   # needed by grub-mkconfig on the first run   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
286   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
287   then   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
  install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die  
  fi  
288    
289   # set kernelopts   # install network config skeleton
290   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]   CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
291   then   clearconfig
292   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die   addconfig 'ONBOOT="yes"'
293   else   addconfig 'NETWORKING="dhcp"'
  echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die  
  fi  
  echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die  
   
  # grub-legacy  
  else  
  ### grubconf schreiben  
  source ${INSTALLROOT}/boot/kernelversion  
294    
295   #for alx only   # intel framebuffer quirk
296   if [ -e ${INSTALLROOT}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]
297     then
298     if [ -e /proc/fb ]
299   then   then
300   OLD_ALXVER="${ALXVER}"   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
301   source ${INSTALLROOT}/etc/alx_version   then
302   KRNVER="ALX-${ALXVER}"   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
303   ALXVER="${OLD_ALXVER}"   if [[ ${fbdev} != 0 ]]
304     then
305     sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
306     fi
307     fi
308   fi   fi
309     fi
310    }
311    
312   [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"  install_umount_rootfs()
313   [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"  {
314   [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
315     is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
316    }
317    
318   # uuid support  install_do_reboot()
319   if is_uuid_supported  {
320   then   reboot
321   my_roothdd="UUID=$(get_uuid ${ROOTHDD})"  }
  else  
  my_roothdd="${ROOTHDD}"  
  fi  
322    
  : > ${grubconf} || dialog_die  
  echo "default 0" >> ${grubconf} || dialog_die  
  echo "timeout 3" >> ${grubconf} || dialog_die  
  # using current root password  
  echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die  
   
  echo  >> ${grubconf} || dialog_die  
  echo "# normal boot" >> ${grubconf} || dialog_die  
  echo "title ${KRNVER}" >> ${grubconf} || dialog_die  
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
323    
324   echo >> ${grubconf} || dialog_die  ### installer dialogs ###
  echo "# admin boot" >> ${grubconf} || dialog_die  
  echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die  
  echo "lock"  >> ${grubconf} || dialog_die  
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
325    
326   echo >> ${grubconf} || dialog_die  dialog_die()
327   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die  {
328   echo "lock"  >> ${grubconf} || dialog_die   ERROR="$1"
329   echo "root (hd0,0)" >> ${grubconf} || dialog_die   RETVAL="$?"
330   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die   dialog_install_failure
331   if is_initrd_supported   exit 1
332   then  }
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
   
  # bootsector schreiben chrooted schreiben (lfs/magellan)  
  cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF  
 /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  
 root (hd0,0)  
 setup (hd0)  
 quit  
 EOF  
 exit 0  
 CHROOTEOF  
  fi  
333    
334   ## enter chroot  dialog_warning()
335   mount -t proc proc ${INSTALLROOT}/proc  {
336   mount -t sysfs sysfs ${INSTALLROOT}/sys   local retval
  mount -o bind /dev ${INSTALLROOT}/dev  
  chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLROOT}/proc  
  umount ${INSTALLROOT}/sys  
  umount ${INSTALLROOT}/dev  
  rm ${INSTALLROOT}/root/.installrc  
 }  
   
 is_initrd_supported()  
 {  
  # only generate initrds if the cmd exists  
  [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0  
  return 1  
 }  
   
 install_initrd_chroot()  
 {  
  # only generate initrds if the cmd exists  
  is_initrd_supported || return 0  
   
  DISKMODS="sd_mod"  
  OLDPATAMODS="amd74xx piix sis5513 via82cxxx"  
  PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"  
  SATAMODS="sata_via sata_sis sata_nv"  
  DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"  
  OTHERMODS=""  
  case ${SPECIALDEVICE} in  
  zotac_intel) FBMODS=""; DRMMODS="i915" ;;  
  zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;  
  rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards  
  # not working with kms enabled drivers -> segfaults  
  #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer  
  maxdata) FBMODS="" ;;  
  *) FBMODS="uvesafb" ;;  
  esac  
337    
338   if [[ ${FORMFACTOR} = laptop ]]   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
339     retval=$?
340     if [[ ${retval} -eq 1 ]]
341   then   then
342   OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"   clear
343     echo $"The process was aborted."
344     exit 1
345   fi   fi
346    }
347    
  # install an appropriate uvesafb.conf  
  install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die  
  echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die  
   
  # install an appropriate viafb.conf  
  echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die  
   
  # install an appropriate i810fb.conf  
  echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die  
   
  cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF  
 echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  
 mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  
 exit 0  
 CHROOTEOF  
348    
349   ## enters chroot  ### installer tasks ###
  mount -t proc proc ${INSTALLROOT}/proc  
  mount -t sysfs sysfs ${INSTALLROOT}/sys  
  mount -o bind /dev ${INSTALLROOT}/dev  
  chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLROOT}/proc  
  umount ${INSTALLROOT}/sys  
  umount ${INSTALLROOT}/dev  
  rm ${INSTALLROOT}/root/.installrc  
 }  
350    
351  is_uuid_supported()  task_setup_system_menu()
352  {  {
353   if [[ -x $(type -P busybox.mkinitrd) ]]   local mode
354     local retval
355    
356     mode="$(dialog_setup_system_menu)"
357     retval=$?
358     [[ ${retval} -eq 1 ]] && return 1
359     if [[ ${retval} -eq 0 ]]
360   then   then
361   # only detect uuids if supported   case "${mode}" in
362   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   "1") run_install_auto ;;
363   then   "2") run_install_normal ;;
364   return 0   "") task_setup_system_menu;;
365   fi   esac
366   fi   fi
   
  return 1  
367  }  }
368    
369  get_uuid()  task_hardware_detection()
370  {  {
371   local UUID   local message
372   local SEC_TYPE  
373   local TYPE   run_hardware_detection_disks
374    
375   local dev="$1"   message+=$"Harddrives:\n"
  [[ -z ${dev} ]] && dialog_die "no dev given"  
376    
377   # check if given device is already an UUID   if [[ ! -z ${ALL_DISKS} ]]
  if [[ ${dev/UUID=/}x != ${dev}x ]]  
378   then   then
379   eval "${dev}"   for i in ${ALL_DISKS}
380   else   do
381   eval $(busybox.mkinitrd blkid ${dev} | grep "${dev}:" | sed 's/.*:\ //')   message+="\Z3${i}\Zn "
382     done
383     message+="\n"
384   fi   fi
  echo "${UUID}"  
 }  
385    
386  install_system_settings()   if [[ ! -z ${ALL_CDROMS} ]]
 {  
  # schreibe fstab  
  if is_uuid_supported  
387   then   then
388   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die   message+="\n"
389   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   message+=$"Optical disk drives:\n"
390   else   for i in ${ALL_CDROMS}
391   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die   do
392   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   message+="\Z3${i}\Zn"
393     done
394     message+="\n"
395   fi   fi
  # not needed busybox loads all with swapon -a, even if not mentioned in fstab  
  #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
   
  # install network config skeleton  
  install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die  
396    
397   # intel framebufer quirk   # other devices
398   if [[ -e /proc/fb ]]   run_hardware_detection
399     case "${SPECIALDEVICE}" in
400     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
401     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
402     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
403     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
404     esac
405     if [[ ${FORMFACTOR} = laptop ]]
406   then   then
407   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
  then  
  fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')  
  if [[ ${fbdev} != 0 ]]  
  then  
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
  fi  
408   fi   fi
409    
410     messagebox -y 12 -h $"Detected hardware:" "${message}"
411  }  }
412    
413  install_system_settings_flash()  task_setup_hdd_partitions_manual()
414  {  {
415   # schreibe fstab   local i
416   if is_uuid_supported   local retval
417    
418     if [[ -z ${ALL_DISKS} ]]
419   then   then
420   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die   dialog_no_harddrive_found
421     exit 1
422   else   else
423   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die   HDD=$(dialog_select_target_harddrive)
424     retval=$?
425     [[ ${retval} -eq 1 ]] && return 1
426     if [[ ${retval} -eq 0 ]]
427     then
428     dialog_setup_hdd_info
429     setup_hdd_partitions_manual
430     fi
431   fi   fi
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
432  }  }
433    
434  install_umount_rootfs()  task_setup_hdd_partitions_auto()
435  {  {
436   cd /   local i
437   umount ${INSTALLROOT}/boot || dialog_die   local retval
  umount ${INSTALLROOT} || dialog_die  
  swapoff ${SWAPHDD} || dialog_die  
 }  
438    
439  install_umount_rootfs_flash()   if [[ -z ${ALL_DISKS} ]]
440  {   then
441   cd /   dialog_no_harddrive_found
442   umount ${INSTALLROOT} || dialog_die   exit 1
443     else
444     HDD=$(dialog_select_target_harddrive)
445     retval=$?
446     [[ ${retval} -eq 1 ]] && return 1
447     if [[ ${retval} -eq 0 ]]
448     then
449     dialog_setup_hdd_info_auto
450     dialog_setup_hdd_create_partitions
451     setup_hdd_partitions_auto
452     fi
453     fi
454  }  }
455    
456  install_do_reboot()  task_main()
457  {  {
458   reboot   local method=0
459  }   local retval
460    
461  #################################################   while [[ ${method} -le 2 ]]
462  #     Install Ablauf Scripte #   do
463  #################################################   method=$(dialog_main)
464     retval=$?
465     [[ ${retval} -eq 1 ]] && exit 1
466     if [[ ${retval} -eq 0 ]]
467     then
468     case ${method} in
469     "1") task_setup_system_menu ;;
470     "2") task_hardware_detection ;;
471     "3") install_do_reboot ;;
472     "4") /bin/bash --login -i ;;
473     esac
474     fi
475     done
476    }
477    
478  run_install_normal()  run_install_normal()
479  {  {
480   dialog_hardware_detection   task_hardware_detection
481    
482   dialog_setup_hdd_partitions_manuell   task_setup_hdd_partitions_manual
483   dialog_setup_hdd_format   dialog_setup_hdd_format
484   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
485   install_mount_rootfs   install_mount_rootfs
486   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
487    
488   dialog_install_settings   dialog_install_settings
489   sleep 1   sleep 1
490   install_system_settings   install_system_settings
491   install_initrd_chroot   if is_initrd_supported
492     then
493     dialog_install_initrd
494     initrd_config
495     initrd_install
496     fi
497    
498   dialog_install_bootsector   dialog_install_bootsector
499   install_bootsector_chroot   bootloader_config
500     bootloader_install
501    
502   install_umount_rootfs   install_umount_rootfs
503   dialog_install_successful   dialog_install_successful
504  }  }
505    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
506  run_install_auto()  run_install_auto()
507  {  {
508   dialog_hardware_detection   task_hardware_detection
509    
510   dialog_setup_hdd_partitions_auto   task_setup_hdd_partitions_auto
511   dialog_setup_hdd_format   dialog_setup_hdd_format
512   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
513   install_mount_rootfs_flash   install_mount_rootfs
514   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
515    
516   dialog_install_settings   dialog_install_settings
517   sleep 1   sleep 1
518   install_system_settings_flash   install_system_settings
519   install_initrd_chroot   if is_initrd_supported
520     then
521     dialog_install_initrd
522     initrd_config
523     initrd_install
524     fi
525    
526   dialog_install_bootsector   dialog_install_bootsector
527   install_bootsector_chroot   bootloader_config
528     bootloader_install
529    
530   install_umount_rootfs_flash   install_umount_rootfs
531   dialog_install_successful   dialog_install_successful
532  }  }
533    
534  dialog_main  # set some proper traps
535    trap "trap_exit" SIGINT SIGQUIT
536    
537    task_main
538    
539  exit 0  exit 0

Legend:
Removed from v.2398  
changed lines
  Added in v.2483